dnl $Id: config.m4,v 1.1 2006/08/31 15:20:53 mikl Exp $
dnl config.m4 for extension ocal
dnl vim:se ts=2 sw=2 et:

PHP_ARG_WITH(ocal, for Oracle Calendar support,
[  --with-ocal[=DIR]       Include Oracle Calendar support. DIR is the libcapi install prefix])

if test -z "$PHP_DEBUG"; then
  AC_ARG_ENABLE(debug,
  [  --enable-debug          compile with debugging symbols],[
    PHP_DEBUG=$enableval
  ],[
    PHP_DEBUG=no
  ]) 
fi

if test "$PHP_OCAL" != "no"; then
  AC_DEFINE(HAVE_OCAL, 1, [ ])

  for i in $PHP_OCAL /usr/local /usr /usr/local/lib/csdk; do
    if test -f $i/lib/libcapi.$SHLIB_SUFFIX_NAME; then
      CAPI_DIR=$i
    fi
  done

  if test -z "$CAPI_DIR"; then
    AC_MSG_ERROR([install the the Oracle Calendar SDK or use --with-ocal=DIR to specify the location.])
  fi

  PHP_CHECK_LIBRARY(capi, CSDK_CreateSession,,[
    AC_MSG_ERROR([failed to find and link against libcapi])
  ],-L$CAPI_DIR/lib)
  
  PHP_ADD_LIBRARY_WITH_PATH(capi, $CAPI_DIR/lib, OCAL_SHARED_LIBADD)
  PHP_ADD_INCLUDE($CAPI_DIR/include)
  PHP_SUBST(OCAL_SHARED_LIBADD)
  
  if test "$PHP_DEBUG" = "yes"; then
    CFLAGS="$CFLAGS -Wall"
  fi

  PHP_NEW_EXTENSION(ocal, ocal.c, $ext_shared)
fi
