<?php

$name = 'ocal';
if (!extension_loaded($name)) {
	echo "Extension $module is not loaded into PHP\n";
	exit(1);
}

$extension = new ReflectionExtension($name);

foreach ($extension->getClasses() as $class) {
	if ($class->isInterface())
		print "interface ";
	else {
		if ($class->isFinal())
			print "final ";
		if ($class->isAbstract())
			print "abstract ";
		print "class ";
	}
	
	print $class->getName()." ";
	if (null != ($parent = $class->getParentClass()))
		print "extends ".$parent->getName()." ";
	
	if (count($class->getInterfaces())) {
		print "implements ";
		foreach ($class->getInterfaces() as $interface)
			print $interface->getName()." ";
	}
	
	print "{\n";
	
	if (count($class->getConstants())) {
		$i = 0;
		
		foreach ($class->getConstants() as $key => $value) {
			if (!$class->getParentClass() || !$class->getParentClass()->hasConstant($key)) {
				print "\tconst $key = ".var_export($value, true).";\n";
				$i++;
			}
		}
		
		if ($i)
			print "\n";
	}

	if (count($class->getProperties())) {
		$values = $class->getDefaultProperties();
		$i = 0;
		
		foreach ($class->getProperties() as $prop) {
			if ($prop->getDeclaringClass() != $class)
				continue;
		
			print "\t";
			
			if ($prop->isPrivate())
				print "private ";
			else if ($prop->isProtected())
				print "protected ";
			else if ($prop->isPublic())
				print "public ";
			if ($prop->isStatic())
				print "static ";
			
			print $prop->getName();
			
			if ($prop->isDefault())
				print " = ".var_export($values[$prop->getName()], true);
			print ";\n";
			$i++;
		}
		
		if ($i)
			print "\n";
	}
	
	foreach ($class->getMethods() as $method) {
		if ($method->getDeclaringClass() != $class)
			continue;
		
		print "\t";
		if ($method->isPrivate())
			print "private ";
		else if ($method->isProtected())
			print "protected ";
		else if ($method->isPublic())
			print "public ";

		if (!$class->isInterface()) {
			if ($method->isAbstract())
				print "abstract ";
			if ($method->isFinal())
				print "final ";
		}
		
		if ($method->isStatic())
			print "static ";
		
		if ($method->returnsReference())
			print "&";
		print $method->getName();
		print "(";
		
		$i = 0;
		$o = 0;
		
		foreach ($method->getParameters() as $param) {
			if ($param->isOptional()) {
				if ($i) print ' ';
				print '[';
				$o++;
			}
			if ($i++) 
				print ', ';
			if ($param->getClass())
				print $param->getClass()->getName().' ';
			else if ($param->isArray())
				print 'array ';
			if ($param->isPassedByReference())
				print '&';
			print $param->getName();
			if ($param->isDefaultValueAvailable())
				print ' = '.var_export($param->getDefaultValue(), true);
		}
		
		while ($o--)
			print ' ]';
		
		print ");\n";
	}
	
	print "}\n\n";
}
