/*
  +----------------------------------------------------------------------+
  | PHP Version 5                                                        |
  +----------------------------------------------------------------------+
  | Copyright (c) 1997-2006 The PHP Group                                |
  +----------------------------------------------------------------------+
  | This source file is subject to version 3.01 of the PHP license,      |
  | that is bundled with this package in the file LICENSE, and is        |
  | available through the world-wide-web at the following url:           |
  | http://www.php.net/license/3_01.txt                                  |
  | If you did not receive a copy of the PHP license and are unable to   |
  | obtain it through the world-wide-web, please send a note to          |
  | license@php.net so we can mail you a copy immediately.               |
  +----------------------------------------------------------------------+
  | Author: Mikael Johansson <mikael AT synd DOT info>                   |
  +----------------------------------------------------------------------+
*/

/* $Id: php_ocal.h,v 1.1 2006/08/31 15:20:53 mikl Exp $ */

#ifndef PHP_OCAL_H
#define PHP_OCAL_H

extern zend_module_entry ocal_module_entry;
#define phpext_ocal_ptr &ocal_module_entry

#ifdef PHP_WIN32
#define PHP_OCAL_API __declspec(dllexport)
#else
#define PHP_OCAL_API
#endif

#ifdef ZTS
#include "TSRM.h"
#endif

#include "ctapi.h"

typedef struct _ocal_session_t {
	CAPISession			handle;
	unsigned 			is_persistent;
} ocal_session_t;

typedef struct _ocal_connection_t {
	zend_object			zo;
	ocal_session_t		*session;
} ocal_connection_t;

typedef struct _ocal_agenda_t {
	zend_object			zo;
	ocal_connection_t	*connection;
	zval				zconnection;
	CAPIHandle			handle;
} ocal_agenda_t;

typedef struct _ocal_composite_agenda_t {
	zend_object			zo;
	ocal_connection_t	*connection;
	zval				zconnection;
	CAPIHandle			*handles;
	unsigned			num_handles;
	zval				*zagendas;
} ocal_composite_agenda_t;

typedef struct _ocal_query_t {
	zend_object			zo;
	CSDKQuery			handle;
} ocal_query_t;

PHP_MINIT_FUNCTION(ocal);
PHP_MSHUTDOWN_FUNCTION(ocal);
PHP_RINIT_FUNCTION(ocal);
PHP_RSHUTDOWN_FUNCTION(ocal);
PHP_MINFO_FUNCTION(ocal);

/*
  	Declare any global variables you may need between the BEGIN
	and END macros here:

ZEND_BEGIN_MODULE_GLOBALS(ocal)
	long  global_value;
	char *global_string;
ZEND_END_MODULE_GLOBALS(ocal)
*/

#ifdef ZTS
#define OCAL_G(v) TSRMG(ocal_globals_id, zend_ocal_globals *, v)
#else
#define OCAL_G(v) (ocal_globals.v)
#endif

#endif	/* PHP_OCAL_H */

/*
 * Local variables:
 * tab-width: 4
 * c-basic-offset: 4
 * End:
 * vim600: noet sw=4 ts=4 fdm=marker
 * vim<600: noet sw=4 ts=4
 */
